/* REXX >NUL 2>&1
@REXX %0 %*
@GOTO :EOF
*/
/*-------------------------------------------------------------------------*/
/* NAME: hotapply.cmd                                                      */
/* PURPOSE: To install the VisualAge TeamConnection code (English only)    */
/*          for: hotfix 3 for fixpak 302                                   */
/* NOTES:                                                                  */
/* * Renames the updated files to *.3$$ and copies new files               */
/*   from a hotfix.                                                        */
/* * The rebind step is included for whatever family is set in TC_FAMILY.  */
/*   User can decline rebind                                               */
/*-------------------------------------------------------------------------*/

'@echo off'
do while queued() > 0
   pull junk
end /* do */
/* call RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'
call SysLoadFuncs */

parse arg source platform .

lessmsg = ' >NUL 2>&1 '
here = directory()
back3 = '3'  /* backup extension for changed files */
env = 'Environment' /* assume windows */
opSys = 'win'

if platform = 'OS/2' then
do
    env = 'OS2ENVIRONMENT'
    opSys = 'os2'
end

TCdir = value( 'TC_HOME',, env )
TCfam = value( 'TC_FAMILY',,env )

TCdll     = TCdir'\dll'
TCexe     = TCdir'\bin'
TCmsg     = TCdir'\nls\msg\enu'
TCcfg     = TCdir'\nls\cfg'
TCcfgENU  = TCdir'\nls\cfg\enu'
TCenu     = TCdir'\enu'
TCsamples = TCdir'\samples'

if stream(TCdll,'c','query datetime') = '' then 
do
  say '*** ERROR *** Cannot find the Team Connection directory: ' TCdir
  say 'Existing now'
  exit 1
end 

say "Copy readme renamed, to easily identify if the hotfix is installed"
newfile = 'readme.HF'||back3
orgfile = 'i302hotfix'||back3||'readme.txt'
'erase readme.hf*  >NUL 2>&1 '
'copy 'orgfile ' ' TCdir'\'newfile
say ' Copy 'orgfile' as ' newfile ' to ' TCdir

say "Copy common files to server and client"
call directory TCdir
here1 = here'\COMMON'
call docopy 'readme.txt', here1
call directory TCenu
call docopy 'readme.txt', here1
call directory TCmsg
call docopy 'teamcv3.cat', here1
call directory TCexe
call docopy 'tclevel.exe', here1

say "Copy server files"
TCchk = TCdir'\NLS\CFG\_tcbase.bnd'
TCcfg = TCdir'\NLS\CFG'
if stream(TCchk,'c','query exists') <> '' then do

/* do dlls first */
  here1 = here'\SERVER'
  call directory TCdll
  'erase *.hf*  >NUL 2>&1 ' /* erase all previous HF dlls'*/
  say "Copy server files: DLLs "
  if opSys = 'win' then do
    call docopy 'FHMHTTPD.DLL',  here1
    call docopy 'FHMBRED.DLL ',  here1
    call docopy 'FHMBUILD.DLL ', here1
    call docopy 'FHMCMNS.DLL ',  here1
    call docopy 'FHMKRNL.DLL ',  here1
    call docopy 'FHMMODEL.DLL ', here1
    call docopy 'FHMMYSTC.DLL',  here1
    call docopy 'FHMSERVR.DLL',  here1
    call docopy 'FHMNETS.DLL',  here1 
    call docopy 'DV8.DLL ',      here1
    call docopy '_ADVIEW.DLL ',  here1
    call docopy '_EWSWERW.DLL ', here1
    call docopy '_EWSWFVT.DLL ', here1
    call docopy '_EWSWHLL.DLL ', here1
    call docopy '_EWSWIMS.DLL ', here1
    call docopy '_EWSWSDD.DLL ', here1
    call docopy '_EWSWSUP.DLL ', here1
    call docopy '_EWSWUIP.DLL ', here1
    call docopy '_EZE2VGX.DLL ', here1
    call docopy '_TCENVY.DLL ',  here1
    call docopy '_UML.DLL ',     here1
   end
  else do  /* OS2 */
    call docopy 'FHCHTTPD.DLL',  here1
    call docopy 'FHCKRNL.DLL',   here1
    call docopy 'FHCMYSTC.DLL',  here1
    call docopy 'FHCSERVR.DLL',  here1
    call docopy 'FHCBRED.DLL ',  here1
    call docopy 'FHBBUILD.DLL ', here1
    call docopy 'FHCCMNS.DLL ',  here1
    call docopy 'FHCMODEL.DLL ', here1

    call docopy 'DV8.DLL ',      here1
    call docopy '_ADVIEW.DLL ',  here1
    call docopy '_EWSWERW.DLL ', here1
    call docopy '_EWSWFVT.DLL ', here1
    call docopy '_EWSWHLL.DLL ', here1
    call docopy '_EWSWIMS.DLL ', here1
    call docopy '_EWSWSDD.DLL ', here1
    call docopy '_EWSWSUP.DLL ', here1
    call docopy '_EWSWUIP.DLL ', here1
    call docopy '_EZE2VGX.DLL ', here1
    call docopy '_TCENVY.DLL ',  here1
    call docopy '_UML.DLL ',     here1

   end
  say "Copy server files: EXEs"
  call directory TCexe
  'erase *.hf*  >NUL 2>&1 ' /* erase all previous HF exe's */
    call docopy 'FHCIRT.EXE', here1
    call docopy 'FHCIRTUP.EXE', here1
    call docopy 'MIGTC.EXE', here1
    call docopy 'MIGCMVC.EXE', here1
    call docopy 'MONITOR.EXE', here1
    call docopy 'TCLICMON.EXE', here1
    call docopy 'UPDVIEWS.BAT', here1

  say "Copy server files: samples"
  call directory TCsamples
  call docopy 'MC0.c', here1

  say "Copy server files: DD*s"
   call directory TCcfg
   call docopy '_ewswsdd.ddl', here1
   call docopy '_ewswsdd.ddv', here1
   call docopy '_ewswsdd.ddt', here1
   call docopy '_ewswerw.ddl', here1
   call docopy '_ewswerw.ddv', here1
   call docopy '_tcbuild.ddl', here1
   call docopy '_tcbuild.ddv', here1
   call docopy 'tccmds.ddl',   here1

  say "Copy server files: configuration files"
   call directory TCcfgENU
   call docopy 'authorit.ld', here1

  say "Copy server files: bind files"
  call directory TCcfg
  'erase *.hf*  >NUL 2>&1 ' /* erase all previous HF files */
  call docopy 'adlink.bnd',   here1
  call docopy 'admerge.bnd',  here1
  call docopy 'adobject.bnd', here1
  call docopy 'adsqlsvr.bnd', here1
  call docopy 'advroot.bnd',  here1
  call docopy 'fhcaccss.bnd', here1
  call docopy 'fhccntxt.bnd', here1
  call docopy 'fhcconfg.bnd', here1
  call docopy 'fhcfgfld.bnd', here1
  call docopy 'fhclevel.bnd', here1
  call docopy 'fhcpath.bnd',  here1
  call docopy 'fhcuser.bnd',  here1
  call docopy 'fhcversn.bnd', here1
  call docopy 'session.bnd',  here1
  call docopy 'tccollc.bnd',  here1
  call docopy 'tctrans.bnd',  here1
  call docopy '_adview.bnd',  here1
  call docopy '_bredidl.bnd', here1
  call docopy '_dvnt.bnd',    here1
  call docopy '_ewswerw.bnd', here1
  call docopy '_ewswfvt.bnd', here1
  call docopy '_ewswhll.bnd', here1
  call docopy '_ewswims.bnd', here1
  call docopy '_ewswsdd.bnd', here1
  call docopy '_ewswsup.bnd', here1
  call docopy '_ewswuip.bnd', here1
  call docopy '_eze2vgx.bnd', here1
  call docopy '_tcbase.bnd',  here1
  call docopy '_tcbuild.bnd', here1
  call docopy '_tcenvy.bnd',  here1
  call docopy '_tcmod.bnd',   here1
  call docopy '_uml.bnd',     here1

  say '********* ATTENTION *****************************************'
  say ' You must re-bind the family data base and update the views.'
  say ' Please refer to the hotfix readme file for details.'
  say '*************************************************************'
  say ' '
end /* do if TCChk exists */

TCchk1 = TCdir'\bin\teamcgui.exe'
if stream(TCchk1,'c','query exists') <> '' then do
  here1 = here'\CLIENT'

  say "Copy client files: EXEs"
  call directory TCexe
  call docopy 'teamcgui.exe', here1

  say "Copy client files: DLLs"
  call directory TCdll
  'erase *.hf*  >NUL 2>&1 ' /* erase all previous HF dlls'*/
    if opSys = 'win' then do
      call docopy 'fhmrscli.dll', here1
      call docopy 'fhmclint.dll', here1
      call docopy 'fhmcmnc.dll',  here1
     end
  /* need these for both */
  call docopy 'fhcrscli.dll', here1
  call docopy 'fhcclint.dll', here1
  call docopy 'fhccmnc.dll',  here1
  call docopy 'fhmnetc.dll',  here1
  call docopy 'teamcgui.exe', here1
end /* if client */

call directory here
say 'Finished. '
return

docopy: procedure expose back3 bkname
  file = arg(1)
  fromdir = arg(2)

  parse var file fname '.' ftype
  newft = substr(ftype,2,2)
  newft = back3 || newft
  bkname = fname ||'.' || newft
  say 'Renaming ' file ' to ' bkname
  'rename' file bkname' >NUL 2>&1 '  /* rename so original backup is never overwritten */
  say 'Copying ' file
  copy fromdir'\'file
 return

/* end of file */
